/*
 * Bill Lin
 * University of California, Berkeley
 * Comments to billlin@ic.Berkeley.EDU
 *
 * Copyright (c) 1989 Bill Lin, UC Berkeley CAD Group
 *     Permission is granted to do anything with this
 *     code except sell it or remove this message.
 */
#include "jedi.h"

int write_one_hot();			/* forward declaration */

write_one_hot(fptr) 
FILE *fptr;
{
    int i, j;
    int c, k, s;
    int ns;
    int n;

    /*
     * print out header
     */
    (void) fprintf(fptr, "#\n");
    (void) fprintf(fptr, "# JEDI, %s\n", RELEASE);
    (void) fprintf(fptr, "#\n");

    i = 0;
    for (k=0; k<ni; k++) {
	if (inputs[k].boolean_flag) {
	    i++;
	} else {
	    c = inputs[k].enumtype_ptr;
	    ns = enumtypes[c].ns;
	    i = i + ns;
	}
    }

    j = 0;
    for (k=0; k<no; k++) {
	if (outputs[k].boolean_flag) {
	    j++;
	} else {
	    c = outputs[k].enumtype_ptr;
	    ns = enumtypes[c].ns;
	    j = j + ns;
	}
    }

    /*
     * print i/o
     */
    (void) fprintf(fptr, ".i %d\n", i);
    (void) fprintf(fptr, ".o %d\n", j);

    /*
     * print out truth table
     */
    for (i=0; i<np; i++) {
        /*
	 * print inputs
	 */
	for (j=0; j<ni; j++) {
	    if (inputs[j].boolean_flag) {
		(void) fprintf(fptr, "%s", inputs[j].entries[i].token);
	    } else {
		if (check_dont_care(inputs[j].entries[i].token)) {
		    c = inputs[j].enumtype_ptr;
		    ns = enumtypes[c].ns;
		    for (n=0;n<ns;n++) {
			(void) fprintf(fptr, "-");
		    }
		} else {
		    c = inputs[j].enumtype_ptr;
		    s = inputs[j].entries[i].symbol_ptr;
		    ns = enumtypes[c].ns;
		    for (n=0;n<ns;n++) {
			if (n == s) {
			    (void) fprintf(fptr, "1");
			} else {
			    (void) fprintf(fptr, "-");
			}
		    }
		}
	    }
	}
	(void) fprintf(fptr, " ");

	/* 
	 * print outputs
	 */
	for (j=0; j<no; j++) {
	    if (outputs[j].boolean_flag) {
		(void) fprintf(fptr, "%s", outputs[j].entries[i].token);
	    } else {
		if (check_dont_care(outputs[j].entries[i].token)) {
		    c = outputs[j].enumtype_ptr;
		    ns = enumtypes[c].ns;
		    for (n=0;n<ns;n++) {
			(void) fprintf(fptr, "0");
		    }
		} else {
		    c = outputs[j].enumtype_ptr;
		    s = outputs[j].entries[i].symbol_ptr;
		    ns = enumtypes[c].ns;
		    for (n=0;n<ns;n++) {
			if (n == s) {
			    (void) fprintf(fptr, "1");
			} else {
			    (void) fprintf(fptr, "0");
			}
		    }
		}
	    }
	}
	(void) fprintf(fptr, "\n");
    }

    /*
     * print ending comment
     */
    (void) fprintf(fptr, ".e\n");
} /* end of write_one_hot */
