#include "mis.h"
#include "bdd_int.h"

void
bdd_cache_insert(table,f,g,h,data)
bdd_table *table;
bdd_node *f,*g,*h,*data;
{
    int pos;
    register bdd_cache *entry;

    pos = bdd_hash((unsigned) f,(unsigned) g,(unsigned) h) % table->slots;
    entry = &table->cache[pos];

#if BDD_STATS
    if (entry->data != NIL(bdd_node)) {
        cachecollisions++;
    }
    cacheinserts++;
#endif

    entry->f = f;
    entry->g = g;
    entry->h = h;
    entry->data = data;
}

bdd_node *
bdd_cache_lookup(table,f,g,h)
bdd_table *table;
bdd_node *f,*g,*h;
{
    int pos;
    register bdd_cache *en,*cache;
    bdd_node *data;

    cache = table->cache;
    if (cache == NIL(bdd_cache)) {
        return(NIL(bdd_node));
    }
    pos = bdd_hash((unsigned) f,(unsigned) g,(unsigned) h) % table->slots;
    en = &cache[pos];

    if (en->data != NIL(bdd_node) && en->f == f && en->g == g && en->h == h) {
        data = BDD_REGULAR(en->data);
#if BDD_STATS
	cachehits++;
#endif
	if (data->ref == 0) {
	    bdd_reclaim(data,table);
	}
        return(en->data);
    }
    return(NIL(bdd_node));
}

