#include "mis.h"
#include "com_int.h"
#include "utility.h"
#include "vov.h"

FILE *
com_open_file(filename, mode, real_filename_p, silent)
char *filename;
char *mode;
char **real_filename_p;
int silent;
{
    char *real_filename, *path, *user_path;
    FILE *fp;

    if (strcmp(filename, "-") == 0) {
	if (strcmp(mode, "w") == 0) {
	    real_filename = util_strsav("stdout");
	    fp = stdout;
	} else {
	    real_filename = util_strsav("stdin");
	    fp = stdin;
	}
    } else {
	real_filename = NIL(char);
	if (strcmp(mode, "r") == 0) {
	    user_path = com_get_flag("open_path");
	    if (user_path != NIL(char)) {
		path = ALLOC(char, strlen(user_path)+strlen(mis_library())+10);
		(void) sprintf(path, "%s:%s", user_path, mis_library());
		real_filename = util_file_search(filename, path, "r");
		FREE(path);
	    }
	}
	if (real_filename == NIL(char)) {
	    real_filename = util_file_expand(filename);
	}
	real_filename = util_strsav( real_filename ); /* Make a local copy of the string. */

	if ((fp = fopen(real_filename, mode)) == NULL) {
	    if (! silent) {
		perror(real_filename);
	    }
	} else {
	    /* File is good. */
	    if ( strcmp( mode, "r" ) == 0 ) {
		VOVinput( VOV_UNIX_FILE, real_filename );
	    } else {
		VOVoutput( VOV_UNIX_FILE, real_filename );
	    }
	}

    }
    if (real_filename_p != 0) {
	*real_filename_p = real_filename;
    } else {
	FREE(real_filename);
    }
    return fp;
}
