#include "genlib_int.h"

static void gl_permute_recur();


gl_permute(array, n, fct, state)
char **array;
int n;
void (*fct)();
char *state;
{
    gl_permute_recur(array, n, n, fct, state);
}


static void
gl_permute_recur(array, m, n, fct, state)
char **array;
int m;	
int n;
void (*fct)();
char *state;
{
    int i;
    char *t;

    if (m <= 1) {
	(*fct)(array-n+1, n, state);
    } else {
	for(i = 0; i < m; i++) {
	    /* Swap first element with ith element */
	    t = array[i];
	    array[i] = array[0];
	    array[0] = t;

	    /* recur for last m-1 elements */
	    gl_permute_recur(array+1, m-1, n, fct, state);

	    /* swap it back */
	    t = array[i];
	    array[i] = array[0];
	    array[0] = t;
	}
    }
}


#ifdef TEST
#include "port.h"

int gl_print_it();


main(argc, argv)
char **argv;
{
    int i, n, array[40];

    if (argc == 2) {
	n = atoi(argv[1]);
    } else {
	printf("usage: permute n\n");
	exit(2);
    }
	
    for(i = 0; i < n; i++) {
	array[i] = i+1;
    }

    gl_permute((char **) array, n, gl_print_it, (char *) 0);
}


gl_print_it(array, n)
char **array;
int n;
{
    int i;
    for(i = 0; i < n; i++) {
	printf(" %d", array[i]);
    }
    printf("\n");
}
#endif
