
#ifndef NO_X

/* RCS Info: $Revision: 1.2 $ on $Date: 89/06/01 16:34:50 $
 *           $Source: /octtools/release-3.0/src/misII/misII/graphics/RCS/XDiamond.c,v $
 * Copyright (c) 1988 Wayne A. Christopher, U. C. Berkeley CAD Group 
 *     faustus@cad.berkeley.edu, ucbvax!faustus
 * Permission is granted to modify and re-distribute this code in any manner
 * as long as this notice is preserved.  All standard disclaimers apply.
 *
 * Converted to X11 by Rick L. Spickelmier
 *
 */

#include <X11/Xlib.h>

void
XDiamondFilled(display, win, gc, x, y, width, height)
    Display *display;
    Window win;
    GC gc;
    int x, y, width, height;
{
    XPoint box[5];

    box[0].x = x;
    box[0].y = y - height / 2 - width / 2;
    box[1].x = x - width / 2 - height / 2;
    box[1].y = y;
    box[2].x = x;
    box[2].y = y + height / 2 + width / 2;
    box[3].x = x + width / 2 + height / 2;
    box[3].y = y;
    box[4].x = box[0].x;
    box[4].y = box[0].y;

#ifdef notdef
    XDrawFilled(win, box, 5, pixel, mode, planes);
#endif
    return;
}

void
XDiamond(display, win, gc, x, y, width, height)
    Display *display;
    Window win;
    GC gc;
    int x, y, width, height;
{
    XPoint box[5];

    box[0].x = x;
    box[0].y = y - height / 2 - width / 2;
    box[1].x = x - width / 2 - height / 2;
    box[1].y = y;
    box[2].x = x;
    box[2].y = y + height / 2 + width / 2;
    box[3].x = x + width / 2 + height / 2;
    box[3].y = y;
    box[4].x = box[0].x;
    box[4].y = box[0].y;

    XDrawLines(display, win, gc, box, 5, CoordModeOrigin);
    return;
}

#endif /* NO_X */
