
#ifndef NO_X

/* RCS Info: $Revision: 1.2 $ on $Date: 89/06/01 16:34:57 $
 *           $Source: /octtools/release-3.0/src/misII/misII/graphics/RCS/XTriangle.c,v $
 * Copyright (c) 1988 Wayne A. Christopher, U. C. Berkeley CAD Group 
 *     faustus@cad.berkeley.edu, ucbvax!faustus
 * Permission is granted to modify and re-distribute this code in any manner
 * as long as this notice is preserved.  All standard disclaimers apply.
 *
 * Converted to X11 by Rick L. Spickelmier
 *
 */

#include <X11/Xlib.h>

void
XTriangleFilled(display, win, gc, x, y, width, height)
    Display *display;
    Window win;
    GC gc;
    int x, y, width, height;
{
    XPoint box[4];

    box[0].x = x;
    box[0].y = y - height / 2 - width / 2;
    box[1].x = box[0].x - width / 2 - height;
    box[1].y = box[0].y + width / 2 + height;
    box[2].x = box[1].x + width + height * 2;
    box[2].y = box[1].y;
    box[3].x = box[0].x;
    box[3].y = box[0].y;

#ifdef notdef
    XDrawFilled(win, box, 4, pixel, mode, planes);
#endif
    return;
}

void
XTriangle(display, win, gc, x, y, width, height)
    Display *display;
    Window win;
    GC gc;
    int x, y, width, height;
{
    XPoint box[4];

    box[0].x = x;
    box[0].y = y - height / 2 - width / 2;
    box[1].x = box[0].x - width / 2 - height;
    box[1].y = box[0].y + width / 2 + height;
    box[2].x = box[1].x + width + height * 2;
    box[2].y = box[1].y;
    box[3].x = box[0].x;
    box[3].y = box[0].y;

    XDrawLines(display, win, gc, box, 4, CoordModeOrigin);
    return;
}

#endif /* NO_X */

