/* RCS Info: $Revision: 1.2 $ on $Date: 89/06/01 16:35:09 $
 *           $Source: /octtools/release-3.0/src/misII/misII/graphics/RCS/dag_util.c,v $
 * Copyright (c) 1985 Wayne A. Christopher, U. C. Berkeley CAD Group
 *
 * Utility routines.
 *
 * Converted to X11 by  Rick L. Spickelmier
 */

#include <ctype.h>
#include "port.h"
#include "utility.h"
#include "graphics_int.h"
#define BSIZE 512

char *
gettok(s)
    char **s;
{
    char buf[BSIZE];
    int i = 0;

    while (isspace(**s))
        (*s)++;
    if (!**s)
        return (NULL);
    while (**s && !isspace(**s))
        buf[i++] = *(*s)++;
    buf[i] = '\0';
    while (isspace(**s))
        (*s)++;
    return (util_strsav(buf));
}

char **
makeLines(text, nump)
    char *text;
    int *nump;
{
    char **lines;
    char *s, *t;
    int i, j;

    if (!text || !*text) {
        *nump = 0;
        return (NULL);
    }
    *nump = 1;
    for (s = text; *s; s++)
        if (*s == '\n')
            *nump++;
    
    lines = ALLOC(char *, *nump);

    for (i = 0, s = text; *s; i++) {
        for (t = s; *t && (*s != '\n'); t++)
            ;
        lines[i] = ALLOC(char, t - s + 1);
        for (j = 0; s < t; s++)
            lines[i][j++] = *s;
        lines[i][j] = '\0';
    }

    return (lines);
}

void
freeLines(lines, numlines)
    char **lines;
    int numlines;
{
    while (--numlines >= 0)
        FREE(lines[numlines]);
    if (lines)
        FREE(lines);
    return;
}
