/* RCS Info: $Revision: 1.2 $ on $Date: 89/06/01 16:35:24 $
 *           $Source: /octtools/release-3.0/src/misII/misII/graphics/RCS/mynames.c,v $
 * Copyright (c) 1988 Wayne A. Christopher, U. C. Berkeley CAD Group 
 *     faustus@cad.berkeley.edu, ucbvax!faustus
 * Permission is granted to modify and re-distribute this code in any manner
 * as long as this notice is preserved.  All standard disclaimers apply.
 *
 * Converted to X11 by Rick L. Spickelmier
 *
 */

#include "graphics_int.h"

char *
dg_type_name(type)
    dg_nodetype type;
{
    switch (type) {
        case DG_INPUT: return ("input");
        case DG_OUTPUT: return ("output");
        case DG_INTERNAL: return ("internal");
        case DG_DUMMY: return ("dummy");
        case DG_UNKNOWN: return ("unknown");
        default: return ("<bad node type>");
    }
}

char *
dg_style_name(style)
    dg_linestyle style;
{
    switch (style) {
        case DG_SOLID: return ("solid");
        case DG_DASHED: return ("dashed");
        case DG_DBLDASHED: return ("dbldashed");
        default: return ("<bad line style>");
    }
}

char *
dg_out_name(out)
    dg_outtype out;
{
    switch (out) {
        case DG_XWINDOW: return ("xwindow");
        case DG_HPGL: return ("hpgl");
        case DG_POSTSCRIPT: return ("postscript");
        case DG_LPR: return ("lpr");
        default: return ("<bad output device>");
    }
}

char *
dg_shape_name(shape)
    dg_nodeshape shape;
{
    switch (shape) {
        case DG_NO_SHAPE: return ("noshape");
        case DG_SQUARE: return ("square");
        case DG_RECTANGLE: return ("rectangle");
        case DG_CIRCLE: return ("circle");
        case DG_ELLIPSE: return ("ellipse");
        case DG_TRIANGLE: return ("triangle");
        case DG_DIAMOND: return ("diamond");
        default: return ("<bad node shape>");
    }
}

dg_nodetype
dg_parse_type(name)
    char *name;
{
    if (eq(name, "input")) return (DG_INPUT);
    else if (eq(name, "output")) return (DG_OUTPUT);
    else if (eq(name, "internal")) return (DG_INTERNAL);
    else if (eq(name, "dummy")) return (DG_DUMMY);
    else if (eq(name, "unknown")) return (DG_UNKNOWN);
    else return ((dg_nodetype) -1);
}

dg_linestyle
dg_parse_style(name)
    char *name;
{
    if (eq(name, "solid")) return (DG_SOLID);
    else if (eq(name, "dashed")) return (DG_DASHED);
    else if (eq(name, "dbldashed")) return (DG_DBLDASHED);
    else return ((dg_linestyle) -1);
}

dg_outtype
dg_parse_out(name)
    char *name;
{
    if (eq(name, "xwindow")) return (DG_XWINDOW);
    else if (eq(name, "hpgl")) return (DG_HPGL);
    else if (eq(name, "postscript")) return (DG_POSTSCRIPT);
    else if (eq(name, "lpr")) return (DG_LPR);
    else return ((dg_outtype) -1);
}

dg_nodeshape
dg_parse_shape(name)
    char *name;
{
    if (eq(name, "noshape")) return (DG_NO_SHAPE);
    else if (eq(name, "square")) return (DG_SQUARE);
    else if (eq(name, "rectangle")) return (DG_RECTANGLE);
    else if (eq(name, "circle")) return (DG_CIRCLE);
    else if (eq(name, "ellipse")) return (DG_ELLIPSE);
    else if (eq(name, "triangle")) return (DG_TRIANGLE);
    else if (eq(name, "diamond")) return (DG_DIAMOND);
    else return ((dg_nodeshape) -1);
}
