

/* RCS Info: $Revision: 1.2 $ on $Date: 89/06/01 16:35:35 $
 *           $Source: /octtools/release-3.0/src/misII/misII/graphics/RCS/uniform.c,v $
 * Copyright (c) 1988 Wayne A. Christopher, U. C. Berkeley CAD Group 
 *     faustus@cad.berkeley.edu, ucbvax!faustus
 * Permission is granted to modify and re-distribute this code in any manner
 * as long as this notice is preserved.  All standard disclaimers apply.
 *
 * Converted to X11 by Rick L. Spickelmier
 *
 */

#include "graphics_int.h"

extern void check_uniform(), insert_dummy();

/* Make sure that every path from the inputs to the outputs of a graph has
 * a node at every level.
 */

void
dg_make_uniform(graph)
    dg_graph *graph;
{
    lsGen gen;
    dg_node *node;

    dg_foreach_node(graph, gen, node)
        if (num_fanins(node) == 0)
            check_uniform(node);
    
    return;
}

static void
check_uniform(node)
    dg_node *node;
{
    lsGen gen;
    dg_arc *arc;
    dg_node *fanout;

    dg_foreach_fanout(node, gen, arc) {
        fanout = arc->to;
        if (fanout->level < node->level - 1)
            insert_dummy(arc, node->level - 1);
    }

    dg_foreach_fanout(node, gen, arc) {
        fanout = arc->to;
        check_uniform(fanout);
    }

    return;
}

static void
insert_dummy(arc, level)
    dg_arc *arc;
    int level;
{
    dg_node *newnode;
    dg_arc *in, *out;
    char *color;
    dg_linestyle style;
    char *label;
    
    newnode = dg_create_node(arc->graph);
    newnode->type = DG_DUMMY;
    newnode->shape = DG_NO_SHAPE;
    newnode->level = level;

    in = dg_create_arc(arc->from, newnode);
    out = dg_create_arc(newnode, arc->to);

    dg_get_arc_props(arc, &color, &style, &label);

    dg_set_arc_props(in, color, style, label);
    dg_set_arc_props(out, color, style, label);

    dg_delete_arc(arc);

    return;
}


