#ifndef ARRAY_H
#define ARRAY_H


typedef struct array_struct array_t;
struct array_struct {
    char *space;
    int num;		/* number of array elements */
    int n_size;		/* size of 'data' array (in objects) */
    int obj_size;	/* size of each array object */
};


extern array_t *array_do_alloc(), *array_dup(), *array_join();
extern void array_free(), array_append(), array_sort(), array_uniq();
extern int array_abort(), array_resize();
extern char *array_do_data();

extern int array_i;


#define array_alloc(type, number)		\
    array_do_alloc(sizeof(type), number)

#define array_insert(type, a, i, datum)		\
    (array_i = (i),				\
      array_i < 0 ? array_abort(0) : 0,		\
      sizeof(type) != (a)->obj_size ? array_abort(1) : 0,\
      array_i >= (a)->n_size ? array_resize(a, array_i + 1) : 0,\
      array_i >= (a)->num ? (a)->num = array_i + 1 : 0,\
      *((type *) ((a)->space + array_i * (a)->obj_size)) = datum)

#define array_fetch(type, a, i)			\
    (array_i = (i),				\
      (array_i < 0 || array_i >= (a)->num) ? array_abort(0) : 0,\
      *((type *) ((a)->space + array_i * (a)->obj_size)))

#define array_insert_last(type, array, datum)	\
    array_insert(type, array, (array)->num, datum)

#define array_fetch_last(type, array)		\
    array_fetch(type, array, (array)->num)

#define array_n(array)				\
    (array)->num

#define array_data(type, array)			\
    (type *) array_do_data(array)

#endif
