/*
 * All exported functions that return a bdd_t are guarenteed to return one
 * with a positive reference count.
 */

 

typedef struct bdd_manager bdd_manager;
typedef struct bdd_t bdd_t;

/*-------- Exported functions ---------*/

	/* bdd_co.c */
extern bdd_t *bdd_cofactor();
extern bdd_t *bdd_compose();

	/* bdd_create.c */
extern bdd_t *bdd_create_variable();
extern bdd_t *bdd_construct();		/* actually in bdd_back.c */
extern bdd_t *bdd_do_construct();		/* actually in bdd_back.c */

	/* bdd_init.c */
extern bdd_manager *bdd_init();
extern void bdd_quit();
extern void bdd_terminate();

	/* bdd_util.c */
extern void bdd_free();
extern void bdd_node_free();
extern bdd_t *bdd_dup();
extern bdd_t *bdd_zero();
extern bdd_t *bdd_one();
extern bdd_t *bdd_constant();		/* actually in bdd_back.c */
extern int bdd_equal();
extern bdd_t *bdd_not();
extern bdd_t *bdd_and();
extern bdd_t *bdd_or();
extern bdd_t *bdd_xor();
extern bdd_t *bdd_xnor();
extern int bdd_leq();
extern int bdd_is_tautology();
extern bdd_t *bdd_then();
extern bdd_t *bdd_else();
extern bdd_t *bdd_top_var();
extern void bdd_print();
extern int bdd_size();

extern lsList network_bdd_list();
extern lsHandle network_add_bdd();
extern bdd_t *bdd_at_node();
extern void bdd_set_at_node();

	/* bdd_verify.c */
extern int bdd_verify();
