#include "mis.h"
#include "com_int.h"


static char *
command_alias_help(command)
char *command;
{
    char *value;
    alias_descr_t *alias;

    if (!avl_lookup(alias_table, command, &value)) {
	return command;
    }
    alias = (alias_descr_t *) value;
    return alias->argv[0];
}

/* ARGSUSED */
com_help(network, argc, argv)
network_t **network;
int argc;
char **argv;
{
    int c, i, all;
    char *key;
    avl_generator *gen;
    char buffer[1024];
    char *command;

    getopt_reset();
    all = 0;
    while ((c = getopt(argc, argv, "a")) != EOF) {
	switch(c) {
	case 'a':
	    all = 1;
	    break;
	default:
	    goto usage;
	}
    }

    if (argc - optind == 0) {
	i = 0;
	avl_foreach_item(command_table, gen, AVL_FORWARD, &key, NIL(char *)) {
	    if ((key[0] == '_') == all) {
		(void) fprintf(misout, "%-15s", key);
		if ((++i%5) == 0) (void) fprintf(misout, "\n");
	    }
	}
	if ((i%5) != 0) (void) fprintf(misout, "\n");

    } else if (argc - optind == 1) {
	command = command_alias_help(argv[1]);
	(void) sprintf(buffer, "more %s/help/%s.fmt", mis_library(), command);
	(void) system(buffer);
    } else {
	goto usage;
    }

    return 0;

usage:
    (void) fprintf(miserr, "usage: help [-a] [command]\n");
    return 1;
}
