#include "mis.h"
#include "io_int.h"


void
write_lif(fp, network, sflag)
FILE *fp;
network_t *network;
int sflag;		/* 1 to write short names rather than long names */
{
    int ninter;
    node_t *p;
    char buffer[1024];
    lsGen gen;

    io_fput_params("\\", 32000);	/* hack until read_blif fixed */

    io_fputs_break(fp, ".circuit ");
    io_fputs_break(fp, network_name(network));
    io_fputc_break(fp, '\n');

    /* count intermediates */
    ninter = 0;
    foreach_node(network, gen, p) {
	if (p->type == INTERNAL && io_po_fanout_count(p, NIL(node_t *)) != 1) {
	    ninter++;
	}
    }

    (void) sprintf(buffer, ".nv %d %d %d\n", 
	network_num_pi(network), network_num_po(network), ninter);
    io_fputs_break(fp, buffer);

    io_fputs_break(fp, ".inputs");
    foreach_primary_input(network, gen, p) {
	io_fputc_break(fp, ' ');
	io_write_name(fp, p, sflag);
    }
    io_fputc_break(fp, '\n');

    io_fputs_break(fp, ".outputs");
    foreach_primary_output(network, gen, p) {
	io_fputc_break(fp, ' ');
	io_write_name(fp, p, sflag);
    }
    io_fputc_break(fp, '\n');

    if (ninter > 0) {
	io_fputs_break(fp, ".intermediates");
	foreach_node(network, gen, p) {
	    if (p->type == INTERNAL && 
			    io_po_fanout_count(p, NIL(node_t *)) != 1) {
		io_fputc_break(fp, ' ');
		io_write_name(fp, p, sflag);
	    }
	}
	io_fputc_break(fp, '\n');
    }

    io_fputs_break(fp, ".begin_elements\n");
    foreach_node(network, gen, p) {
	(void) sprintf(buffer, ".cover %d %d %d", 
	    node_num_fanin(p), 1, node_num_cube(p));
	io_write_node(fp, buffer, p, sflag);
    }
    io_fputs_break(fp, ".end_elements\n");
}
