#include "mis.h"

void
init_mis()
{
#if defined(bsd4_2) || defined(sun)	/* hack, but its nice to have ... */
    setlinebuf(stdout);
    setlinebuf(stderr);
#endif
#ifdef OCT
    errProgramName("MIS - Version 2.2");
    errCore(1);
#endif

    misout = stdout;
    miserr = stderr;
    init_command();	/* must be first */
    init_node();
    init_network();
    init_io();
    init_extract();
    init_factor();
    init_decomp();
    init_resub();
    init_delay();
    init_map();
    init_phase();
    init_pld();
    init_sim();
    init_simplify();
    init_gcd();
    init_octio();
    init_bdd();
    init_maxflow();
    init_speed();
    init_atpg();
    init_graphics();
    init_test();
}


void
end_mis()
{
    end_test();
    end_graphics();
    end_atpg();
    end_speed();
    end_maxflow();
    end_bdd();
    end_octio();
    end_gcd();
    end_simplify();
    end_sim();
    end_phase();
    end_pld();
    end_map();
    end_delay();
    end_resub();
    end_decomp();
    end_factor();
    end_extract();
    end_io();
    end_network();
    end_command();
    end_node();		/* should be last (to discard daemons) */
    if (misout != stdout) (void) fclose(misout);
    if (miserr != stderr) (void) fclose(miserr);
    misout = stdout;
    miserr = stderr;
    sf_cleanup();
}
