#include "mis.h"
#include "utility.h"

#ifndef CUR_DATE
#define CUR_DATE	"<compile date not supplied>"
#endif

#ifndef CUR_VER
#define CUR_VER		"UC Berkeley, MIS Release #2.2"
#endif

#ifndef LIBRARY
#define LIBRARY		"$OCTTOOLS/lib/misII/lib"
#endif


/*
 * Returns the date in a brief format assuming its coming from
 * the program `date'.
 */
static char *
proc_date(datestr)
char *datestr;
{
    static char result[25];
    char day[10], month[10], zone[10], *at;
    int date, hour, minute, second, year;

    if (sscanf(datestr, "%s %s %2d %2d:%2d:%2d %s %4d",
	   day, month, &date, &hour, &minute, &second, zone, &year) == 8) {
	if (hour >= 12) {
	    if (hour >= 13) hour -= 12;
	    at = "PM";
	} else {
	    if (hour == 0) hour = 12;
	    at = "AM";
	}
	(void) sprintf(result, "%d-%3s-%02d at %d:%02d %s", 
	    date, month, year % 100, hour, minute, at);
	return result;
    } else {
	return datestr;
    }
}



/*
 * Returns the current MIS version string to the caller.
 */

char *
mis_version()
{
    static char version[1024];

    (void) sprintf(version, "%s(AC) (compiled %s)", CUR_VER, proc_date(CUR_DATE));
    return version;
}


/*
 *  Returns the MIS library path (usually $OCTTOOLS/lib/misII/lib) to the caller
 */

char *
mis_library()
{
    return util_file_expand(LIBRARY);
}
