 /* file bin_int.h release 1.4 */
 /* last modified: 9/9/90 at 17:31:59 */
#ifndef BIN_INT_H
#define BIN_INT_H

 /* historically, for binned load values; now we use PWL's */

#define BIN_SLOT		bin
#define BIN(node)		((bin_t *) (node)->BIN_SLOT)

#include "pwl.h"

typedef struct {
  pwl_t *rise;
  pwl_t *fall;
} pwl_delay_t;

typedef struct delay_bucket_struct delay_bucket_t;
typedef struct delay_bucket_struct {
  lib_gate_t *gate;
  int ninputs;
  node_t **save_binding;
  pwl_delay_t pwl;
  delay_bucket_t *next;	/* used in chain of buckets to free them all */
};

typedef struct {
  lib_gate_t *gate;
  int ninputs;
  node_t **save_binding;
  double area;
} area_bucket_t;

typedef struct {
  pwl_delay_t pwl;
  area_bucket_t area; 
} bin_t;


 /* to pass options */

typedef struct bin_global_struct bin_global_t;
struct bin_global_struct {
  int new_mode; 	        /* new_mode */
  double new_mode_value;	/* 0.0->area ... 1.0->delay */
  int load_bins_count;		/* for newmap delay and area/delay */
  int delay_bins_count;		/* for newmap area/delay */
  double old_mode;		/* old map; area or delay optimize */
  int inverter_optz;		/* inverter optimization heuristics */
  int allow_internal_fanout;	/* degrees of internal fanouts allowed */
  int print_stat;		/* print area/delay stats at the end */
  int verbose;			/* verbosity level */
  int raw;			/* raw mapping */
  double thresh;		/* threshold used in old tree mapper */
  library_t *library;		/* current library */
  int fanout_optimize;		/* if set, the fanout optimizer is called */
  int area_recover;		/* if set, area is recovered after fanout opt */
  int peephole;			/* if set, call fanout peephole optimizer */
  array_t *fanout_alg;		/* array of fanout algorithm descriptors */
  int remove_inverters;		/* if set, remove redundant inverters after mapping */
};

 /* EXPORTED FROM "bin_delay.c" */
extern void bin_delay_tree_match();
extern void bin_print_gate_stats();
extern void bin_for_all_nodes_inputs_first(/* network_t *network; VoidFn fn; */);
extern void bin_for_all_nodes_outputs_first(/* network_t *network;VoidFn fn; */);

 /* EXPORTED FROM "treemap.c" */
extern network_t *do_old_tree_match();


#endif 
