 /* file map_macros.h release 1.3 */
 /* last modified: 9/9/90 at 17:32:12 */
#ifndef MAP_MACROS_H
#define MAP_MACROS_H

#include "map_defs.h"
#define DISCRETIZATION_FACTOR 100

#define SETSUB(a,b,c) ((a).rise=(b).rise-(c).rise, (a).fall=(b).fall-(c).fall)
#define SETADD(a,b,c) ((a).rise=(b).rise+(c).rise, (a).fall=(b).fall+(c).fall)
#define GETMIN(a) MIN((a).rise, (a).fall)
#define GETMAX(a) MAX((a).rise, (a).fall)
#define SETMIN(a,b,c) ((a).rise=MIN((b).rise, (c).rise), (a).fall=MIN((b).fall,(c).fall))
#define SETMAX(a,b,c) ((a).rise=MAX((b).rise, (c).rise), (a).fall=MAX((b).fall,(c).fall))
#define SETMAX2(a,b)  ((a)=((a)>(b))?(a):(b))
#define SETMIN2(a,b)  ((a)=((a)<(b))?(a):(b))
#define IS_EQUAL(a,b) (FP_EQUAL((a).rise,(b).rise) && FP_EQUAL((a).fall,(b).fall))
#define IS_BETTER(a,b) ((a).rise>=(b).rise && (a).fall>=(b).fall)

#include "bin_int.h"

#define MIN_ARRIVAL(node) (BIN((node))->arrival->min_arrival)
#define MAX_ARRIVAL(node) (BIN((node))->arrival->max_arrival)
#define MIN_AREA(node) (BIN((node))->arrival->min_area)
#define MAP_ARRIVAL(node) (MAX(MAP((node))->map_arrival.rise, \
  MAP((node))->map_arrival.fall))

#endif
