 /* file pwl.h release 1.3 */
 /* last modified: 9/9/90 at 17:32:13 */
#ifndef PWL_H
#define PWL_H

#include "utility.h"
#include "array.h"

#define array_fetch_p(type, a, i)                       \
    (array_i = (i),                             \
      (array_i < 0 || array_i >= (a)->num) ? array_abort(0) : 0,\
      ((type *) ((a)->space + array_i * (a)->obj_size)))



 /* implements piece-wise linear scalar valued functions */

typedef struct {
  double x;
  double y;
  double slope;
  char *data;
} pwl_point_t;

typedef struct {
  int n_points;
  pwl_point_t *points;
} pwl_t;

#ifndef MAP_DEFS_H
typedef void (*VoidFn)();
#endif

#ifndef INFINITY
#define INFINITY 0x7fffffff
#endif

extern pwl_t *pwl_min(/* pwl_t *f1, pwl_t *f2 */);
extern pwl_t *pwl_create_linear_max(/* int n_points; pwl_point_t *points; */);
extern pwl_t *pwl_dup(/*  pwl_t *f; */);

 /* sort the points if necessary; should be made same interface as create_linear_max */
extern pwl_t *pwl_create(/*  array_t *points; */);
 /* does not sort */
extern pwl_t *pwl_extract(/*  array_t *points; */);
extern void pwl_free(/* pwl_t *f; */);
extern void pwl_print(/* FILE *fp; pwl_t *f; VoidFn print_data; */);
extern void pwl_set_data(/* pwl_t *pwl; char *data; */);
extern pwl_point_t *pwl_lookup(/* pwl_t *f; double x; */);
extern double pwl_point_eval(/* pwl_point_t *point, double x */);
extern char *pwl_point_data(/* pwl_point_t *point */);
extern pwl_t *pwl_create_empty(/* */);

#endif 
