#include "mis.h"


/*
 *  network_cleanup -- remove internal nodes with no fanout; this is iterated
 *  until every node has fanout > 0.
 */


int 
network_cleanup(network)
network_t *network;
{
    node_t *p;
    int some_change, changed;
    lsGen gen;

    some_change = 0;
    do {
	changed = 0;
	foreach_node(network, gen, p) {
	    if (p->type == INTERNAL && node_num_fanout(p) == 0) {
		network_delete_node_gen(network, gen);
		changed = 1;
		some_change = 1;
	    }
	}
    } while (changed);

    return some_change;
}
