#include "mis.h"


int
network_sweep_node(node)
node_t *node;
{
    int i, some_change, changed;
    node_t *fanin;
    node_function_t func;

    changed = 0;

    if (node->type == PRIMARY_OUTPUT) {
	/* For a primary output, only sweep away a buffer node */
	fanin = node_get_fanin(node, 0);
	if (node_function(fanin) == NODE_BUF) {
	    assert(node_patch_fanin(node, fanin, node_get_fanin(fanin, 0)));
	    changed = 1;
	}
    } else {
	do {
	    some_change = 0;
	    foreach_fanin(node, i, fanin) {
		func = node_function(fanin);
		if (func == NODE_0 || func == NODE_1 || func == NODE_BUF 
							|| func == NODE_INV) {
		    (void) node_collapse(node, fanin);
		    some_change = 1;
		    changed = 1;
		    break;
		}
	    }
	} while (some_change);
    }
    return changed;
}


int
network_sweep(network)
network_t *network;
{
    int i, changed;
    array_t *node_vec;
    node_t *node;

    node_vec = network_dfs(network);

    changed = 0;
    for(i = 0; i < array_n(node_vec); i++) {
	node = array_fetch(node_t *, node_vec, i);
	if (network_sweep_node(node)) {
	    changed = 1;
	}
    }

    /* delete nodes with no fanout */
    if (network_cleanup(network)) {
	changed = 1;
    }

    array_free(node_vec);
    return changed;
}
