#include "pld.h"
/* definitions for actel */
#define IMPROPER 0
#define PROPER 1
/* #define NULL 0 */
#define FALSE 0
#define HICOST 100000
#define DELETE 3
#define NO_VALUE 4
#define FANIN 0
#define RANDOM 1
#define OPTIMAL 2
#define COMPOSE 0
#define ALAP 3
#define HEURISTIC 4
#define MAXSTYLES 6
#define MAXTYPES 5
/* #define MAXOPTIMAL 6 */
#define AND     0
#define OR      4
#define P11     0
#define P10     1
#define P01     2
#define P00     3
#define XOR    8
#define XNOR   9
#define min(A,B) ( (A) < (B) ? (A) : (B) )
#undef equal
#define PLD_SLOT pld	
#define ACT_SET(node)	((act_type_t *) (node)->PLD_SLOT)
#define ACT_GET(node)	((node)->PLD_SLOT)
#define GLOBAL_ACT act_num[0]
#define LOCAL_ACT act_num[1]

#define A_F 1.0;
#define S_F 0.0;
#define ACT_MAP_NAME   actel_map

/*    DAG vertex	*/
typedef struct act_vertex_defn {
    struct act_vertex_defn *low, *high;
    int index;
    int value;
    int id;
    int mark;
    int index_size;
    node_t *node;
    char *name;
    int multiple_fo; 
    int cost;
    int pattern_num;			  /* for the pattern_matched at a node */
    int mapped;
    struct act_vertex_defn *parent;
    char *fn_string; 			  /* for storing the function at a vertex */
    int my_type ;   			  /* PROPER or IMPROPER */
} ACT_VERTEX, *ACT_VERTEX_PTR;
#define act_t ACT_VERTEX


/*	ACT with root, name, and order_list	*/
	typedef struct act_defn {
		ACT_VERTEX_PTR root;
		array_t *node_list;
		node_t *node;
		char *node_name;		
	} ACT, *ACT_PTR;

/*	ACT and order style	*/
	typedef struct act_entry_defn{
		ACT_PTR act;
		int order_style;		
	} ACT_ENTRY, *ACT_ENTRY_PTR;

/*	local and global ACTs	*/
	typedef struct act_slot_defn{
		ACT_ENTRY_PTR act_num[2];
	} act_type_t;

/*	used in act2ntwk and reduce	*/
	typedef struct key_defn{
                int low, high;
                int low_sign, high_sign;
        } KEY;
	
	typedef struct queue_node_defn{ 
                KEY key;
                ACT_VERTEX_PTR v; 
        } Q_NODE, *Q_NODE_PTR; 

typedef struct cost_struct_defn{
	int cost;
        char *fn_type;
	ACT_VERTEX_PTR  act;
 } COST_STRUCT;



/*	global	*/

	array_t *index_list_array;
	array_t *index_list_array2;
	array_t *global_lists;
        
	extern void p_actAlloc();			/* act_init.c	*/
	extern void p_actFree();			/* act_init.c	*/
	extern void local_actFree();			/* act_init.c	*/
	extern void p_actDup();				/* act_init.c	*/
	extern int p_actRemove();			/* act_remove.c	*/
	extern void p_actDestroy();			/* act_remove.c	 */
	extern void p_dagDestroy();			/* act_remove.c	 */
        extern void p_actCreate4Set();
        extern void p_addLists();
        extern void p_applyCreate();
	extern void traverse();			 /*	act_trav.c*/	
	extern ACT_VERTEX_PTR actReduce();			/*act_reduce.c*/	

extern void init_multiple_fo_array( /* VERTEX_PTR act_of_node */ );
extern int map_act( /* VERTEX_PTR vertex */ );
extern st_table *end_table;					/* needed in make_bdd() urp_bdd.c*/
extern network_t *act_map_network(); /* act_map.c */
extern network_t *act_break_network(); /*act_map.c */
extern void act_act_free();
extern void free_cost_struct();
extern COST_STRUCT *make_tree_and_map();
extern int WHICH_ACT;    /* act_map.c */
extern int print_network();
extern FILE *BDNET_FILE;  /* com_pld.c */
extern int ACT_DEBUG;  /*  com_pld.c */
extern int ACT_STATISTICS;  /*  com_pld.c */
/* Definitions for Xilinx*/

/* xln_merge and xln_map_par*/
#define MAX_MATCHING	1000
#define MAXINT          100000000
#define BUFSIZE		500

#define SOURCE_NAME	"source"
#define SINK_NAME	"sink"

#define ON		1
#define OFF		0
#define YES		1
#define NO		0
#define OK		1
extern void		merge_node();
extern void		partition_network();
extern void		change_edge_capacity();
extern int		get_maxflow();
extern char 		*formulate_Lindo();  
extern mf_edge_t	*get_maxflow_edge();
extern node_t		*graph2network_node();
extern void		print_fanin();
extern int		comp_ptr();
extern void		count_intsec_union();
extern enum st_retval	print_table_entry();
extern void		print_array();
/**********/
/* macros */
/**********/

/* Macro procedure that swaps two entities. */
/*------------------------------------------*/
#define  SWAP(type, a, b)   {type swapx; swapx = a; a = b; b = swapx;}


/* Macro to copy a string: it returns the pointer to the string */
/*--------------------------------------------------------------*/
#define SAVE(ptostring)  strcpy(CALLOC(char,strlen(ptostring)+1),ptostring)

/* Macro for random number generation */
/*------------------------------------*/
#define RAND(a) ( a = ( a * 1103515245 + 12345 ) & MAX_INT ))
#define NORM(n) ( (double) n / (double) MAX_INT )
#define NRAND(a) ( (double) ( a = ( a * 1103515245 + 12345 ) & MAX_INT ) / (double) MAX_INT )


#define RINT(a) ( (int) floor( (double) a + 0.5 ) )

/* xln_part.c */
typedef struct a_node_struct {
    float value;
    char *name;
    char *fanout;
} a_node, *a_node_ptr;


typedef struct a_divisor {
    node_t *divisor;
    int kernelsize;
} divisor_t;

typedef struct a_kern_node{
    node_t *node;
    array_t *cost_array;
} kern_node;

/* xln_k_decomp.c and xln_ufind.c*/

typedef struct tree_node{
   int index;
   struct   tree_node *parent;
   int num_child;
   int class_num;
   } tree_node;


  extern void xl_binary1();      /*xln_aux.c */
  extern int intlog2();      /*xln_aux.c */
  extern tree_node *find_tree();  /*xln_ufind.c */
  extern int unionop();		  /* xln_ufind.c */


  extern node_t   *dec_node_cube();     /* xln_aodecomp.c */
  
  extern int pld_decomp_and_or();      /* xln_part_dec.c */
