typedef struct sim_flag_struct {
    sim_method_t method;
    sim_accept_t accept;
    sim_dctype_t dctype;
} sim_flag_t;

#define SIM_SLOT		 simplify
#define SIM_FLAG(node)		 ((sim_flag_t *) ((node)->SIM_SLOT))

typedef struct cspf_struct{
    node_t  *node;
    int     level;
} cspf_type_t;

#define OBS cspf
#define CSPF(node)  ((cspf_type_t *) (node)->OBS)

/* constants for filtering */
#define F_SET 1
#define DC_SET 2
#define SIZE_BOUND 3
#define DIST_BOUND 2
#define sm_ncols(M) M->ncols

/* simp_dc.c */
extern int    simp_fanin_level;
extern int    simp_fanin_fanout_level;
extern bool   simp_debug;
extern bool   simp_trace;

/* simp_dc.c */
extern node_t *simp_all_dc();
extern node_t *simp_tfanin_dc();
extern node_t *simp_fanout_dc();
extern node_t *simp_inout_dc();
extern node_t *simp_sub_fanin_dc();

/* filter.c */
extern node_t *simp_dc_filter();

/* simp_daemon.c */
extern void   simp_alloc();
extern void   simp_free();
extern void   simp_invalid();
extern void   simp_dup();

/* filter_util.c */
extern void	 fdc_sm_bp_1();
extern void	 fdc_sm_bp_2();
extern void	 fdc_sm_bp_4();
extern void	 fdc_sm_bp_6();
extern void	 fdc_sm_bp_7();
extern array_t	 *sm_col_count_init();
extern sm_col	 *sm_get_long_col();

/* simp_sm.c */
extern sm_matrix *simp_node_to_sm();
extern node_t	 *simp_sm_to_node();
extern void 	 simp_sm_print();

/* simp_order.c */
extern array_t   *simp_order();

/* cspf_io.c */
extern int com_print_exdc();
extern int com_print_stats_exdc();
extern int com_print_io_exdc();
extern void simplify_cspf_node();
