#include "mis.h"

int fsize_cmp();

typedef struct node_fsize_t_defn {
    node_t *node;
    int fsize;
} node_fsize_t;

array_t *
simp_order(nodevec)
array_t *nodevec;
{
    node_t *cn;
    node_fsize_t *new_entry, *this_entry;
    array_t *list;
    int i, fac_size;

    list = array_alloc(node_fsize_t *, 0);
    for (i = 0; i < array_n(nodevec); i ++) {
	cn = array_fetch(node_t *, nodevec, i);
	fac_size = factor_num_literal(cn);
	new_entry = ALLOC(node_fsize_t, 1);
	new_entry->node = cn;
	new_entry->fsize = fac_size;
	array_insert(node_fsize_t *, list, i, new_entry);
    }

    array_sort(list, fsize_cmp);
    for (i = 0; i < array_n(list); i ++) {
	this_entry = array_fetch(node_fsize_t *, list, i);
	array_insert(node_t *, nodevec, i, this_entry->node);
	FREE(this_entry);
    }

    array_free(list);
    return(nodevec);
}

int fsize_cmp(obj1, obj2)
char **obj1;
char **obj2;
{
    node_fsize_t *fsize_struct1, *fsize_struct2;

    fsize_struct1 = *((node_fsize_t **) obj1);
    fsize_struct2 = *((node_fsize_t **) obj2);

    if (fsize_struct1->fsize < fsize_struct2->fsize)
	return(1);
    else if (fsize_struct1->fsize < fsize_struct2->fsize) 
	return(-1);
    else 
	return(0);
}
