/*
 * GLOBAL variables used in the speedup package
 */
extern int         sp_add_inv;
extern int         speed_debug;
extern int         speed_repeat;
extern int         weight_debug;
extern int 	   speed_area_reclaim;
extern double      speed_thresh;
extern st_table    *speed_plot_table;

typedef struct speed_global_delay_data{
    delay_model_t model;	/* Delay model to use */
    int library_accl;		/* FLAG: Use accelrator for the mapped model*/
    double pin_cap;		/* Capacitance of the input pin */
    delay_pin_t nand_pin_delay;/* Delay model for the 2-input primitives */
    delay_pin_t inv_pin_delay;	/* Delay model for the invertor */
    } speed_delay_global_t;

extern speed_delay_global_t sp_glb_delay;
/*
 * Function declarations as extern in the package 
 */
extern int         speed_weight();
extern int         com__speed_plot();
extern int         speed_and_decomp();
extern int         speed_init_decomp();
extern int         speed_delay_trace();
extern int         speed_and_or_decomp();
extern int         speed_decomp_network();
extern int  	   speed_get_library_accl();
extern int         speed_update_arrival_time();
extern int         speed_delay_parameters_dup();
extern void 	   speed_absorb();
extern void 	   speed_absorb_array();
extern void        speed_up_node();
extern void        speed_up_loop();
extern void        speed_up_script();
extern void        speed_up_network();
extern void        set_speed_thresh();
extern void        speed_node_replace();
extern void        speed_adjust_phase();
extern void        speed_update_fanout();
extern void 	   speed_set_library_accl();
extern void        speed_set_arrival_time();
extern void        speed_plot_crit_network();
extern void        speed_reset_arrival_time();
extern void        speed_del_critical_cubes();
extern void        speed_delay_arrival_time();
extern void        speed_single_level_update();
extern void        speed_network_delete_node();
extern void        speed_delete_single_fanin_node();
extern bool        speed_critical();
extern node_t      *name_to_node();
extern node_t      *node_del_two_cubes();
extern node_t      *speed_dec_node_cube();
extern node_t      *speed_node_conditional();
extern array_t     *speed_decomp();
extern array_t     *network_to_array();
extern array_t     *network_and_node_to_array();
extern st_table    *speed_levelize_crit();
extern st_table    *speed_compute_weight();
extern network_t   *speed_network_create_from_node();
extern lib_gate_t  *sp_get_gate();
extern lib_gate_t  *sp_lib_get_inv();
extern lib_gate_t  *sp_lib_get_buffer();

/* 
 * MACRO definitions for the speedup package 
 */
#define D_MIN(a,b) ((double)(a) < (double)(b) ? (double)(a):(double)(b))
#define D_MAX(a,b) ((double)(a) > (double)(b) ? (double)(a):(double)(b))

/*
 * Definition of some constants
 */
#define MIN_AREA_BUF_NAME ""


#define DEFAULT_SPEED_THRESH 0.5
#define DEFAULT_SPEED_COEFF 0.0
#define DEFAULT_SPEED_DIST 3

#ifndef POS_LARGE
#define POS_LARGE 10000
#endif

#ifndef NEG_LARGE
#define NEG_LARGE -10000
#endif

#define MAXWEIGHT 1000

/*
 * Definitions of mathematical constants
 */
#define SP_PI    3.14159265358979323846
#define SP_PI_2  1.57079632679489661923
#define SP_PI_4  0.78539816339744830962
#define SP_1_PI  0.31830988618379067154
