#include "mis.h"
#include "speed_int.h"

void
speed_up_loop(network, thresh, coeff , dist, model, flag)
network_t **network;
double thresh, coeff;
int dist, flag;     /* Flag is for the Trace printing */
delay_model_t model;
{
    network_t *cur_net;
    double best, cur;

    if ( flag) (void) fprintf(misout,"distance = %-2d  threshold = %3.1f\n", dist, thresh);
    assert(delay_trace(*network, model));
    (void) delay_latest_output(*network, &cur);

loop:     
    cur_net = network_dup(*network);
    speed_up_network(cur_net, thresh, coeff, dist, model);

    assert(delay_trace(cur_net, model));
    (void) delay_latest_output(cur_net, &best);

    if ( best < cur ) {
	if ( flag) {
	    (void) fprintf(misout,"\tDelay  %5.2f -> %5.2f\n", cur, best);
	}
	cur = best;
	network_free( *network);
	*network = cur_net;
    	goto loop;
    }

    if ( speed_debug) {
	if ( flag) {
	    (void) fprintf(misout,"\t\tDelay  %5.2f -> %5.2f\n", cur, best);
	}
    }

    /* 
     * At this stage try once more to speed up 
     */

    speed_up_network(cur_net, thresh, coeff, dist, model);
    assert(delay_trace(cur_net, model));
    (void) delay_latest_output(cur_net, &best);

    if ( best < cur ) {
	if ( flag) {
	    (void) fprintf(misout,"\tDelay  %5.2f -> %5.2f\n", cur, best);
	}
	cur = best;
	network_free( *network);
	*network = cur_net;
    	goto loop;
    }

    if ( flag) {
    (void) fprintf(misout,"\tDelay  %5.2f -> %5.2f\n", cur, cur);
    }

    network_free( cur_net);
}


void
speed_up_script(network, model, coeff, flag)
network_t **network;
delay_model_t model;
double coeff;
int flag;
{
	speed_up_loop(network, DEFAULT_SPEED_THRESH, coeff, 
		DEFAULT_SPEED_DIST, model, flag);
	speed_up_loop(network, DEFAULT_SPEED_THRESH, coeff, 
		DEFAULT_SPEED_DIST + 1, model, flag);
	speed_up_loop(network, DEFAULT_SPEED_THRESH, coeff, 
		DEFAULT_SPEED_DIST + 2, model, flag);
	speed_up_loop(network, DEFAULT_SPEED_THRESH, coeff, 
		DEFAULT_SPEED_DIST + 1, model, flag);
	speed_up_loop(network, DEFAULT_SPEED_THRESH, coeff, 
		DEFAULT_SPEED_DIST, model, flag);
}
