#include "copyright.h"
#include "mustang.h"


/*
 *    ***********************************
 *    *** SEQUENTIAL STATE ASSIGNMENT ***
 *    ***********************************
 *
 *  Srinivas Devadas
*/
extern void reverse();

assign_sequential_codes()
{
/*
* Assign sequential codes to the states and quit
*/

 int i, j, num_codes;
 char encode[ID_LENGTH];


  for(i=1;i<=node_num;i++) {
    num_codes = i;
    for(j=0;j<num_states;j++) {
      if (num_codes % 2 is 1)
        encode[j] = '1';
      else if (num_codes % 2 is 0)
        encode[j] = '0';
      num_codes /= 2;
    }
    encode[num_states] = '\0';
    reverse(encode);
    (void) strcpy(nodes[i]->code[0],encode);
    (void) strcpy(nodes[i]->code[1],encode);
  }

 return;

} /* end of assign_sequential_codes */


assign_random_codes()
{
/*
* Assign random codes to the states and quit.
*/

 int i, j, num_codes, encode_num;
 char encode[ID_LENGTH];
 char *enc_list;
 extern long time();

  encode_num = 1;
  for(i=0;i<num_states;i++)
    encode_num *= 2;

  enc_list = ALLOC(char, encode_num + 1);
  for(i=0;i<encode_num + 1;i++)
    enc_list[i] = FALSE;

  if (real_ran)
    srandom((int) time(NIL(long)));
    
  for(i=1;i<=node_num;i++) {

    num_codes = random() % encode_num ;
    while (enc_list[num_codes] is TRUE)
      num_codes = random() % encode_num;

    enc_list[num_codes] = TRUE;
    for(j=0;j<num_states;j++) { 
      if (num_codes % 2 is 1)
        encode[j] = '1';
      else if (num_codes % 2 is 0)
        encode[j] = '0';
      num_codes /= 2;
    }
    encode[num_states] = '\0';
    reverse(encode);
    (void) strcpy(nodes[i]->code[0],encode);
    (void) strcpy(nodes[i]->code[1],encode);
  }

 return;

} /* end of assign_sequential_codes */
